#!/usr/bin/perl

# license = gpl
# author = jacob jarick, mem.namefix@gmail.com , mem on #wiidev @ efnet

#--------------------------------------------------------------------------------------------------------------
# includes
#--------------------------------------------------------------------------------------------------------------

use CGI qw /:standard -nosticky/;
use Cwd;
use warnings;
use File::Copy;
use FindBin;


#--------------------------------------------------------------------------------------------------------------
# variables
#--------------------------------------------------------------------------------------------------------------

our $dir = $0;

$dir =~ s/\\/\//g;
$dir =~ s/^(.*)\/(.*?)$/$1/;

our %conf = &read_config();
our $theme = $conf{'theme'};

do "$dir/config.pl" or die "ERROR: couldnt load $dir/config.pl";


$version = "0.3.0.1";
$wd	= cwd();
$i_wd	= $wd; 		# inital wd, needed for memcoder etc

$mf_ext = "avi|mpeg|mpg|mov|flv|dat|asf|wmv|mp4|ogm|mkv|vob";

$file 		= param('file');
$name		= param('name');
$action 		= param('action');
$our_wd		= param('our_wd');
$new_theme	= param('theme');

$ico_pic 	= "$theme_dir/ico_img.png";
$ico_mp3 	= "$theme_dir/ico_mp3.png";
$ico_vid 	= "$theme_dir/ico_vid.png";
$ico_zip 	= "$theme_dir/ico_zip.png";
$ico_dir 	= "$theme_dir/ico_dir.png";
$ico_txt 	= "$theme_dir/ico_txt.png";
$ico_home	= "$theme_dir/ico_home.png";
$ico_up		= "$theme_dir/ico_up.png";
$ico_bin		= "$theme_dir/ico_bin.png";
$ico_play	= "$theme_dir/ico_play.png";
$ico_del		= "$theme_dir/ico_del.png";
$ico_config	= "$theme_dir/ico_config.png";
$ico_links	= "$theme_dir/ico_links.png";
$ico_forward	= "$theme_dir/ico_fwd.png";
$ico_back	= "$theme_dir/ico_back.png";
$ico_flash	= "$theme_dir/ico_flash.png";
$background	= "$theme_dir/background.jpg";

our @drives_data = ();
our @table_data = ();
our @info = ();
our @html = &readf("$theme_local_dir/main.html");

$date = localtime(time());


#--------------------------------------------------------------------------------------------------------------
# code
#--------------------------------------------------------------------------------------------------------------

print "Content-type: text/html\n\n";

if($our_wd)
{
	chdir $our_wd;
	$wd = $our_wd;
}
else
{
	$our_wd = cwd;
}

#--------------------------------------------------------------------------------------------------------------
# get drives data ready.

@drives_data = &readf("$tpl_local_dir/drives_header.tpl");
@tmp = &readf("$tpl_local_dir/drives_body.tpl");

for $d(@drives)
{
	@tmp2 = @tmp;
	for $line(@tmp2)
	{
		$line =~ s/<<drive>>/$d/ig;
		push @drives_data, $line;
	}
}
push @drives_data, &readf("$tpl_local_dir/drives_footer.tpl");

#--------------------------------------------------------------------------------------------------------------
# get link_buttons data ready.

my @link_buttons = &readf("$tpl_local_dir/link_buttons.tpl");
for(@link_buttons)
{
	s/<<theme_dir>>/$theme_dir/ig;
	s/<<cgi>>/$cgi_dir/ig;
	s/<<wiicr_dir>>/$wiicr_dir/ig;
}

#$vars_data = "<!-- VARS \n\$file = $file\n\$action = $action\n\$our_wd = $our_wd\n-->\n";

#--------------------------------------------------------------------------------------------------------------
# respond to cgi requests

if(!$action)
{
	@info = &lsdir;
}

elsif($action eq "favs")
{
	@info = &readf("$tpl_local_dir/favs_header.tpl");
	@favs = &readf("$favourites");
	@tmp = &readf("$tpl_local_dir/favs_body.tpl");
	for(@favs)
	{
		chomp;
		@tmp2 = @tmp;
		($name, $file) = split(/\t+/);
		for(@tmp2)
		{
			s/<<file>>/$file/ig;
			s/<<name>>/$name/ig;
			s/<<ico_dir>>/$ico_dir/ig;
		}
		push @info, @tmp2;
	}
	push @info, &readf("$tpl_local_dir/favs_footer.tpl");
}

elsif($action eq "vidplay")
{
	$count = param('count');
	$count++;
	$file = "$count"."default.flv";
	$tmpdur = $duration + $refresh_delay;
	
	if(! -f "$flv_local_dir/$file")
	{
		@info = &readf("$tpl_local_dir/error.tpl");
		for(@info)
		{
			$tmp = "video file: $file doesnt exist<BR/>Assuming Video Ended.";
			s/<<error_message>>/$tmp/ig;
		}
	}
	else
	{
		@info = &readf("$tpl_local_dir/vidplay.tpl");
		for(@info)
		{
			s/<<cgi>>/$cgi_dir/ig;
			s/<<file>>/$file/ig;
			s/<<count>>/$count/ig;
			s/<<duration>>/$tmpdur/ig;
			s/<<theme_dir>>/$theme_dir/ig;
			s/<<link_buttons>>/@link_buttons/ig;
		}
		print @info;
		exit 1;
	}
}

elsif($action =~ /^vidiframe/i)
{
	my $count = $action;
	$count =~ s/^vidiframe//;
	print "\$count = $count<br>";
	$count++;
	print "\$count = $count<br>";
	$file = "$count"."default.flv";
	$tmpdur = $duration + $refresh_delay;

	@info = &readf("$tpl_local_dir/vidiframe.tpl");

	if(! -f "$flv_local_dir/$file")
	{
		@info = &readf("$tpl_local_dir/error.tpl");
		for(@info)
		{
			$tmp = "video file: $file doesnt exist<BR/>Assuming Video Ended.";
			s/<<error_message>>/$tmp/ig;
		}
	}
	else
	{
		print "$file = $file<br>$count<br>";
		@info = &readf("$tpl_local_dir/vidiframe.tpl");
		for(@info)
		{
			s/<<cgi>>/$cgi_dir/ig;
			s/<<file>>/$file/ig;
			s/<<count>>/$count/ig;
			s/<<duration>>/$tmpdur/ig;
			s/<<theme_dir>>/$theme_dir/ig;
		}
		print @info;
		exit 1;
	}
}

elsif($action eq "config")
{

	@info = &readf("$tpl_local_dir/config.tpl");
	@tmp = &read_dir("$wiicr_local_dir/themes");
	
	my @combo = ("<select NAME=\"theme\">");
	for(@tmp)
	{
		if($_ eq "." || $_ eq "..")
		{
			next;
		}
		push @combo, "<option value=\"$_\">$_</option>";
		
	}
	push @combo, "</select>";
	for(@info)
	{
		s/<<cgi>>/$cgi_dir/ig;
		s/<<theme_combo>>/@combo/ig;
	}
}

elsif($action eq "theme")
{
	@tmp = &readf("$wiicr_local_dir/config.dat");
	open(FILE, ">$wiicr_local_dir/config.dat") or die "";
	for(@tmp)
	{
		chomp;
		if(/^theme\s+=/i)
		{
			print FILE "theme = $new_theme\n";
		}
		else
		{
			print FILE "$_\n";
		}
	}
	close(FILE);

	@info 		= &readf("$tpl_local_dir/msg.tpl");
	@msg 		= ("Changing themes now");
	$goto_url	= "$cgi_dir/index.pl";
	
	for(@info)
	{
		s/<<goto_url>>/$goto_url/ig;
		s/<<msg>>/@msg/ig;
	}

}

elsif($action eq "pls_del")
{
	open(FILE, ">$mp3_pls") or die "";
	close(FILE);
	open(FILE, ">$mp3_txt") or die "";
	close(FILE);

	@info 		= &readf("$tpl_local_dir/msg.tpl");
	@msg 		= ("Playlist Cleared, returning to config menu.");
	$goto_url	= "$cgi_dir/index.pl?action=config";
	
	for(@info)
	{
		s/<<goto_url>>/$goto_url/ig;
		s/<<msg>>/@msg/ig;
	}

}

elsif($action eq "pls_update")
{
	&update_mp3_pls;
	@info 		= &readf("$tpl_local_dir/msg.tpl");
	@msg 		= ("Playlist Updated, returning to config menu.");
	$goto_url	= "$cgi_dir/index.pl?action=config";
	
	for(@info)
	{
		s/<<goto_url>>/$goto_url/ig;
		s/<<msg>>/@msg/ig;
	}

}

elsif($action eq "jobs_del")
{
	opendir(DIR, "$work_dir") or die "couldnt open dir: \"$work_dir\" to read\n";
	@dir = readdir(DIR);
	close(DIR);
	
	for(@dir)
	{
		if($_ !~ /\.(bat|sh)$/i)
		{
			next;
		}
	}

	@info 		= &readf("$tpl_local_dir/msg.tpl");
	@msg 		= ("Jobs cleared, returning to config menu.");
	$goto_url	= "$cgi_dir/index.pl?action=config";
	
	for(@info)
	{
		s/<<goto_url>>/$goto_url/ig;
		s/<<msg>>/@msg/ig;
	}

}

elsif($action eq "playlist")
{
	@info = ();
	push @info, &readf("$tpl_local_dir/playlist_header.tpl");
	@tmp = &lsmp3dir;
	push @info, @tmp;
	push @info, &readf("$tpl_local_dir/playlist_footer.tpl");
}

elsif($action eq "delete")
{
	@info =  &readf("$tpl_local_dir/playlist_del.tpl");
	for(@info)
	{
		s/<<name>>/$name/ig;
		s/<<file>>/$file/ig;
		s/<<ico_config>>/$ico_config/ig;
		s/<<cgi>>/$cgi_dir/ig;
	}
	@tmp = &readf("$mp3_txt");
	open(FILE, ">$mp3_txt") or die "couldnt open $mp3_txt to update";

	$c = 0;
	for(@tmp)
	{
		chomp;
		if(/$file$/)
		{
			$c++;
			next;
		}
		if($c != $file)
		{
			print FILE "$_\n";
		}
	$c++;
	}
	&update_mp3_pls;	
}

elsif($action eq "drive")
{
	chdir $file;
	chdir "/";
	$wd = cwd();
	@info = &lsdir;
}

elsif($action eq "file" and -d $file)
{
	chdir $file;
	$wd = cwd();
	@info = &lsdir;
}

elsif($action eq "file" and $file =~ /\.swf$/ig)
{
	@info = &lsdir;

	@info 		= &readf("$tpl_local_dir/msg.tpl");
	@msg 		= ("Trying to load $file.");

	$loc 		= "";
	$loc 		= "$our_wd/$file";
	$loc		= CGI::escapeHTML($loc);

	$goto_url	= "$cgi_dir/fileget.php?loc=".$loc;

	for(@info)
	{
		s/<<goto_url>>/$goto_url/ig;
		s/<<msg>>/@msg/ig;
	}
}

elsif($action eq "file" && -f $file && $file =~ /\.(txt|bat|ini|nfo)$/i)
{
	@file = &readf("$file");
	@info = &readf("$tpl_local_dir/txt_display.tpl");
	for(@info)
	{
		s/<<file>>/@file/ig;
	}
	
}

elsif($action eq "links")
{
	@info = &readf("$links");
	for(@info)
	{
		$_ =~ s/^\s*-\s*/<hr style=\"width:80%;\"\/>/;
		$_ =~ s/^b$/<br\/>/i;
		$_ =~ s/(.*)\t+(.*)/<font size=\"5\"><a href=\"$2\">$1<\/a><\/font><br\/>\n/;
	}
}

elsif($action eq "file" && -f $file && $file =~ /\.(jpg|gif|png|jpeg)$/i)
{
	my $loc="$wd/$file";
	$loc = CGI::escapeHTML($loc);
	@tmp = &read_dir("$our_wd");
	@tmp2 = ();
	for(@tmp)
	{
		if(/\.(jpg|gif|png|jpeg)$/i)
		{
			push @tmp2, $_;
		}
	}
	
	$file_forward = $file_back = $tmp2[0];
	
	$count = 1;
	my $s = scalar @tmp2;
	for(@tmp2)
	{
		if(/^$file$/)
		{
			if($count == $s)
			{
				$file_forward = $tmp2[0];
			}
			else
			{
				$file_forward = $tmp2[($count)];
			}
			if($count == 0)
			{
				$file_back = $tmp2[($s - 1)];
			}
			else
			{
				$file_back = $tmp2[($count - 2)];
			}
		}
		$count++;
	}
	
	@info = &readf("$tpl_local_dir/pic_display.tpl");
	for(@info)
	{
		s/<<icon_back>>/$ico_back/ig;
		s/<<icon_forward>>/$ico_forward/ig;
		s/<<loc>>/$loc/ig;
		s/<<cwd>>/$our_wd/ig;
		s/<<file>>/$file/ig;
		s/<<file_back>>/$file_back/ig;
		s/<<file_forward>>/$file_forward/ig;				
	}
	
}

elsif($action eq "file" && -f $file && $file =~ /\.(mp3|m3u|pls)$/i)
{
	@info = &readf("$tpl_local_dir/mp3.tpl");
	for(@info)
	{
		s/<<theme_dir>>/$theme_dir/ig;
		s/<<ico_play>>/$ico_play/ig;
	}

	if($file =~ /mp3$/i)
	{
		$t = "$our_wd\/$file\n";
	}
	else
	{	# assuming playlist
	
		$t = "";
		@tmp = &readf("$our_wd/$file");
		chomp (@tmp);
		if($file =~ /\.m3u$/i)
		{
			for (@tmp)
			{
				if(/^#/)
				{
					next;
				}
				s/\\/\//g;
				if(!/^(\/|\w:)/)
				{
					$_ = "$our_wd/$_";
				}
				$t .= "$_\n";
			}
		}
		else
		{
			# assume pls
			$t = "";
			for(@tmp)
			{
				if(!/^File/i)
				{
					next;
				}
				s/\\/\//g;
				s/^File\d+\=//ig;
						
				print "<!-- $_ -->\n";	
				if(!/^(\/|\w:)/i)
				{
					$_ = "$our_wd/$_";
				}
				$t .= "$_\n";
			}
		}
	}

	open(FILE, ">>$mp3_txt") or die "ERROR couldnt open $mp3_txt";
	print FILE $t;
	close(FILE);

	&update_mp3_pls;	
}

elsif($action eq "file" and -f $file && $file =~ /\.($mf_ext)$/i)
{
	$cmd = "\"$perl_exe\" \"$cgi_local_dir/encode.pl\" \"$our_wd\/$file\"";
	$rand = rand();
	open(FILE, ">>$work_dir/$rand.bat");
	print FILE "$cmd\n";
	close(FILE);

	@info = &readf("$tpl_local_dir/encoding.tpl");
	for(@info)
	{
		s/<<ico_play>>/$ico_play/ig;
		s/<<theme_dir>>/$theme_dir/ig;
	}
}

elsif($action eq "file" and !-f $file)
{
	$cwd = cwd();
	$error_msg = "sorry we cant see $file in current directory: $cwd";
	@info = &readf("$tpl_local_dir/error.tpl");
	for(@info)
	{
		s/<<error_msg>>/$error_msg/ig;
	}
}

#--------------------------------------------------------------------------------------------------------------
# Done everything, file in template and print webpage



for (@html)
{
	s/<<drives>>/@drives_data/ig;
	s/<<info>>/@info/ig;
	s/<<date>>/$date/ig;
	s/<<theme_dir>>/$theme_dir/ig;
	s/<<vars>>/$vars_data/ig;
	s/<<background>>/$background/ig;
	s/<<version>>/$version/ig;
	s/<<cgi>>/$cgi_dir/ig;
	s/<<wiicr_dir>>/$wiicr_dir/ig;
	s/<<link_buttons>>/@link_buttons/ig;
}

print @html;
exit 1;

#--------------------------------------------------------------------------------------------------------------
# subroutines
#--------------------------------------------------------------------------------------------------------------

sub read_dir_s
{
	my $d = shift;
	my @dl_1 = ();
	my @dl_2 = ();
	my @dl_3 = ();
	my @dl_4 = ();


	opendir(DIR, "$d") or nf_error("sub readdir cant open directory $d, $!");
	@dl_1 = readdir(DIR);
       	closedir DIR;

	for(@dl_1) 
	{
		if($_ eq ".") 
		{
			next;
		}
		push @dl_2, $_;
	}

	for(@dl_2)
	{
		if(-d $_)
		{
			push @dl_3, $_;
		}
		else
		{
			push @dl_4, $_;
		}
	}
	
	@dl_3 = sort(@dl_3);
	@dl_4 = sort(@dl_4);
	
	push @dl_3, @dl_4;

        return @dl_3;
}

#--------------------------------------------------------------------------------------------------------------

sub lsdir 
{
	my @dir = &read_dir_s(".");
	my @data = ();
	my @tmp = ();
	my @tmp2 = ();
	my $file = "";
	
	@tmp = &readf("$tpl_local_dir/dir_header.tpl");
	for(@tmp)
	{
		s/<<cwd>>/$wd/ig;
	}
	
	push @data, @tmp;
	
	for(@dir)
	{
		if(!$_)
		{
			next;
		}
		$ico_tmp = $ico_bin;
		
		if(-d $_ && $_ eq "..")
		{
			$ico_tmp = $ico_up;
		}		
		elsif(-d $_)
		{
			$ico_tmp = $ico_dir;
		}		
		elsif(/\.(txt|ini|nfo)$/i)
		{
			$ico_tmp = $ico_txt;
		}		
		elsif(/\.(mp3|m3u|pls)$/i)
		{
			$ico_tmp = $ico_mp3;
		}		
		elsif(/\.swf$/i)
		{
			$ico_tmp = $ico_flash;
		}		
		elsif(/\.(jpg|jpeg|gif|png|bmp)$/i)
		{
			$ico_tmp = $ico_pic;
		}		
		elsif(/\.($mf_ext)$/i)
		{
			$ico_tmp = $ico_vid;
		}
		elsif(/\.(zip|ace|tar|gz|rar|r\d{2})$/i)
		{
			$ico_tmp = $ico_zip;
		}		
		
		$file = $_;

		@tmp = &readf("$tpl_local_dir/dir_body.tpl");
		for(@tmp)
		{
			s/<<file>>/$file/ig;
			s/<<icon>>/$ico_tmp/ig;
			s/<<cwd>>/$wd/ig;
			
		}
		
		push @data, @tmp;
	}
	push @data, &readf("$tpl_local_dir/dir_footer.tpl");
	
	return @data;
}

#--------------------------------------------------------------------------------------------------------------
sub lsmp3dir
{
	my @mp3_list = &readf("$mp3_txt");
	my @data = ();
	my @tmp = &readf("$tpl_local_dir/playlist_body.tpl");

	my $c = 0;
	for(@mp3_list)
	{
		if(!$_)
		{
			$c++;
			next;
		}

		$name = $_;
		$name =~ s/.*\/(.*?\.mp3)$/$1/ig;
		@tmp2 = @tmp;
		for(@tmp2)
		{
			s/<<cwd>>/$wd/ig;
			s/<<file>>/$c/ig;
			s/<<name>>/$name/ig;			
			s/<<ico_del>>/$ico_del/ig;
		}
		push @data, @tmp2;
		$c++;
	}
	return @data;
}


#--------------------------------------------------------------------------------------------------------------

sub readf 
{
        my $file = $_[0];

        open(FILE, "$file") or die("ERROR: Couldnt open $file to read.\n");
        my @file = <FILE>;
        close(FILE);

        return @file;
        
        return 1;
}

#--------------------------------------------------------------------------------------------------------------
# update_mp3_pls

# Note: its only xml code in this sub, 0 html.

sub update_mp3_pls 
{
	my @tmp 		= &readf("$mp3_txt");
	my $tmp2 	= "";
	my $file		= "";

	@tmp = &uniq_arr(@tmp);
	
	open(FILE, ">$mp3_pls");
	print FILE
	"<playlist version=\"1\" xmlns=\"http://xspf.org/ns/0/\">\n\t<trackList>\n\n";
	for(@tmp)
	{
		chomp;
		$_ =~ s/\n|\r//;
		$_ =~ s/\s+$//;
		$_ =~ s/^\s+//;

		if($_ !~ /\.mp3$/i)
		{
			next;
		}
		if(/\'/)	# atm we dont handle ' well (seems only win32)
		{
			next;
		}
		if(/^\/\//)	# we also dont handle network paths right now.
		{
			next;
		}
		if( !-f $_)
		{
			next;
		}
		$file = $_;
		$file =~ s/^.*\///ig;
		$file =~ s/\.mp3$//ig;
		$_ = CGI::escapeHTML($_);

		print FILE 
		"\t<track>\n\t\t<title>$file</title>\n\t\t<creator></creator>\n\t\t<location>$wiicr_dir/fileget.php?loc=$_</location>\n\t</track>\n\n";
	}
	
	print FILE 
	"\t</trackList>\n</playlist>\n";
	close(FILE);

	return 1;
}

sub uniq_arr
{
	my @list = @_;

	my %seen = ();
	my @uniqu = grep { ! $seen{$_} ++ } @list;
	
	return @uniqu;
}

sub read_config
{
	my %conf;
	
	my @tmp = &readf("$dir/config.dat");
	for(@tmp)
	{
		chomp;                  # no newline
		s/#.*//;                # no comments
		s/^\s+//;               # no leading white
		s/\s+$//;               # no trailing white
		next unless length;     # anything left?
		my ($var, $value) = split(/\s*=\s*/, $_, 2);
		$conf{$var} = $value;		
	}

	return %conf;
}

sub read_dir
{
	my $d = shift;
	
	opendir(DIR, "$d") or die "ERROR: read_dir couldnt open \"$d\"";
	my @data = readdir(DIR);
	close(DIR);
	
	return @data;
	
}

1;